@ECHO OFF
:: =====================================================
:: - Batch-Name: 3P-News.BAT                           -
:: =====================================================
:: -          Batch by Uwe Morgener - 05.2003          -
:: -       fuer Crosspoint (XP2/OpenXP) und UKAW       -
:: -----------------------------------------------------
:: - Zweck: diverse Unterprogramme um den fr Menpunkt-
:: - ====== "News nur senden" realisieren zu knnen    -
:: -                                                   -
:: - UKAW bietet dafr keinen speziellen Parameter,    -
:: - daher mssen die Listen der bestellten Bretter    -
:: - (*.RC), die REQUEST.ID "auer Sichtweite gebracht"-
:: - werden und leere Dummy-Listen der bestellten      -
:: - Bretter erstellt werden.                          -
:: -----------------------------------------------------
:: - Die Verlagerung dieser Aufgaben in diese Batch    -
:: - sollte die Anpassung von 3P-Batch erleichtern,    -
:: - falls UKAW einmal einen separaten Parameter fr   -
:: - "News nur senden" anbietet.                       -
:: -----------------------------------------------------
:: -        (gehrt zum Paket: 3P-Batch v1.20)         -
:: -----------------------------------------------------
::
:: %1 enthlt die Sprungmarke (entspricht den Namen des "Unterprogramms")
:: kein Unterprogramm gewhlt? (Achtung: /Rekursiver Aufruf/)
IF %1'==' CALL 3P-Sub NoSubDef ErrShow
IF %1'==' GOTO Ende
::
:: Pfade zu der Request.ID und den RC-Dateien festlegen
::    ist XP2
IF %XPv%'==0' SET RC_Path=%XP%
IF %XPv%'==0' SET ID_Path=%XP%
::    ist OpenXP
IF %XPv%'==1' SET RC_Path=%PPP%
IF %XPv%'==1' SET ID_Path=%XP%
::
:: Hilfsvariablen fr den Verzeichniswechsel per DOS-Befehl CD setzen
:: (Ist %RC_Path% ein Rootverzeichnis (%RC_Path%==%Drive%) eines Laufwerks,
:: dann mu "CD \" anstatt "CD %RC_Patch%" zum Wechsel in dieses Verzeichnis
:: ausgefhrt werden)
SET RC_Path1=%RC_Path%
IF %RC_Path%'==%Drive%' SET RC_Path1=\
SET ID_Path1=%ID_Path%
IF %ID_Path%'==%Drive%' SET ID_Path1=\
::
:: Hilfsvariable initialisieren
SET _NewsErr=
::
:: Unterprogramm "anspringen"
GOTO %1

:: =====================================================================
:: "HighLevel-Fehlertexte" ---------------------------------------------
:NoDelRC ------ konnte nicht alle Dummy-Brett-Listen (*.RC) lschen
IF %_NewsErr%'==' SET _NewsErr=NoDelRC
:NoRenRC$ ------ konnte nicht alle gesicherten Brett-Listen (*.RC$) in *.RC umbenennen
IF %_NewsErr%'==' SET _NewsErr=NoRenRC$
:NoRenID1 ------ Umbenennung der Request.id in Request.id_ fehlgeschlagen
IF %_NewsErr%'==' SET _NewsErr=NoRenID1
:NoRenID2 ------ Umbenennung der Request.id$ in Request.id fehlgeschlagen
IF %_NewsErr%'==' SET isnID=
IF %_NewsErr%'==' SET _NewsErr=NoRenID2
:CopyIdEr ------ Zusammenfhrung der Request.id$+Request.id_ zu Request.id fehlgeschlagen
IF %_NewsErr%'==' SET _NewsErr=CopyIdEr
:NoDelID$ ------ Konnte Request.id$ nicht lschen
IF %_NewsErr%'==' SET _NewsErr=NoDelID$
:NoDelID_ ------ Konnte Request.id_ nicht lschen
IF %_NewsErr%'==' SET _NewsErr=NoDelID_
GOTO ErrEnde2

:isRC$ ------ "auer Sichtweite gebrachte" Brettlisten (*.RC$) vorhanden
IF %_NewsErr%'==' SET _NewsErr=isRC$
:NoRenRC ------ /nicht/ alle Brettlisten (*.RC) "auer Sichtweite gebracht"
IF %_NewsErr%'==' SET _NewsErr=NoRenRC
:isID$ ------ "auer Sichtweite gebrachte" REQUEST.ID$ vorhanden
IF %_NewsErr%'==' SET _NewsErr=isID$
:isID_ ------ Umbenannte neue (nach "News nur senden") REQUEST.ID noch vorhanden.
IF %_NewsErr%'==' SET _NewsErr=isID_
GOTO ErrEnde1

:Err3Pa ------ Fehler in 3Pa.exe aufgetreten
:: wurden die DOS-Umgebungsvariablen nicht/falsch gesetzt, so wurde
:: keine "temp.bat" erstellt, sondern Meldung nur auf Bildschirm
:: ausgegeben und ERRORLEVEL auf 253 gesetzt
IF ERRORLEVEL==253 IF NOT ERRORLEVEL==254 GOTO ErrEnde3
:: %UKAwPara%, %Para1% und ggf. %Para2% setzen (temp.bat wurde
:: von 3Pa.exe geschrieben, sofern darin ein Fehler auftrat)
CALL %RAM%\temp.bat
DEL %RAM%\temp.bat
SET _NewsErr=%UKAwPara%
GOTO ErrEnde1

:ErrEnde1
CD %PPP%
:: Fehlermeldung anzeigen und ins Log-File schreiben (3P-Batch.log)
CALL 3P-Sub %_NewsErr% ErrShow
:ErrEnde3
SET UKAwPara=/NoCall
GOTO Ende

:ErrEnde2
CD %PPP%
:: Fehlermeldung anzeigen und ins Log-File schreiben (3P-Batch.log)
CALL 3P-Sub %_NewsErr% ErrShow /No
:: Definition der Hilfsvariablen wieder aufheben
FOR %%S IN (NewSize CopySize) DO SET %%S=
GOTO Ende

:: =====================================================================
:: spezielle Fehlerroutine fr SndNews ---------------------------------
:SplitErr
:: %UKAwPara%, %Para1% und ggf. %Para2% setzen (temp.bat wurde
:: von 3Pa.exe geschrieben, sofern darin ein Fehler auftrat)
CALL %RAM%\temp.bat
:: kein ReqIdErr-Fehler, dann Fehler anzeigen und Netcall abbrechen
IF NOT %UKAwPara%'==ReqIdErr' GOTO Err3Pa
:: ReqIdErr-Fehler (Format der Request.id nicht bekannt) aufgetreten
DEL %RAM%\temp.bat
:: Variablen sichern, da sie in ErrShow gelscht werden
SET _Mail=%Mail%
SET _News=%News%
:: Fehlermeldung anzeigen und ins Log-File schreiben (3P-Batch.log)
CD %PPP%
CALL 3P-Sub %UKAwPara% ErrShow /No
:: Hilfsvariablen lschen
FOR %%S IN (UKAwPara Para1 Para2) DO SET %%S=
:: gesicherte Variablen wiederherstellen
SET Mail=%_Mail%
SET News=%_News%
:: Zusatzmeldung ndern
SET MID_Req=Mail- und News-MID-Requests deaktiviert.
:: weiter im Unterprogramm "SndNews"
GOTO MID_Req
:: =====================================================================

:Hangup ---------- Unterprogramm "Hangup"
:: "News nur senden" war nicht gewhlt worden, dann nur beenden
IF NOT EXIST %RAM%\3P-News.tmp GOTO Ende
:: Semaphore lschen - hat seinen Zweck erfllt
IF EXIST %RAM%\3P-News.tmp DEL %RAM%\3P-News.tmp
::
:: falls "News nur senden" gewhlt wurde, dann Dummy-Listen der bestellten 
:: Bretter lschen, echte Liste der bestellten Bretter wieder "sichtbar 
:: machen" und gesicherte Request.id$ & Request.id zusammenfhren
CD %RC_Path1%
:: Dummy-Brett-Liste (*.RC) nur lschen, wenn auch eine Kopie der originalen
:: Brett-Liste (*.RC$) gleichen Namens existiert
IF EXIST *.RC$ IF EXIST *.RC FOR %%D IN (*.RC) DO IF EXIST %%D$ DEL %%D
::   konnten alle Dummy-Brett-Listen (*.RC) gelscht werden?
IF EXIST *.RC$ IF EXIST *.RC GOTO NoDelRC
:: echte Liste der bestellten Bretter wieder "sichtbar machen"
IF EXIST *.RC$ REN *.RC$ *.RC
::   konnten alle *.RC$ in *.RC zurckbenannt werden?
IF EXIST *.RC$ GOTO NoRenRC$
::
CD %ID_Path1%
:: die Request.id$ ggf. direkt in Request.id umbenennen
SET isnID=0
:: merken, ob "exist *.ID$ not exist *.ID" - notwendig fr die 
:: anschlieende Fehlerabfrage: "Request.id$ umbenannt?"
IF EXIST REQUEST.ID$ IF NOT EXIST REQUEST.ID SET isnID=1
IF %isnID%'==1' REN REQUEST.ID$ REQUEST.ID
::   konnte die REQUEST.ID$ umbenannt werden?
IF %isnID%'==1' IF EXIST REQUEST.ID$ GOTO NoRenID2
SET isnID=
::
IF EXIST REQUEST.ID$ IF EXIST REQUEST.ID REN REQUEST.ID REQUEST.ID_
::   konnte die REQUEST.ID umbenannt werden?
IF EXIST REQUEST.ID$ IF EXIST REQUEST.ID GOTO NoRenID1
::
:: existieren beide Request.id /nicht/, dann berspringen
IF NOT EXIST REQUEST.ID$ IF NOT EXIST REQUEST.ID_ GOTO Skip
CD %PPP%
CALL VAR SET ID$Size=SIZE OF %ID_Path%\REQUEST.ID$
CALL VAR SET ID_Size=SIZE OF %ID_Path%\REQUEST.ID_
IF %ID$Size%'==' SET ID$Size=0
IF %ID_Size%'==' SET ID_Size=0
CALL VAR SET CopySize=%ID_Size%+%ID$Size%
:: Definition der Hilfsvariablen wieder aufheben
FOR %%S IN (ID_Size ID$Size) DO SET %%S=
CD %ID_Path1%
COPY /B REQUEST.ID$+REQUEST.ID_ REQUEST.ID > NUL
CD %PPP%
CALL VAR SET NewSize=SIZE OF %ID_Path%\REQUEST.ID
IF NOT %CopySize%'==%NewSize%' GOTO CopyIdEr
CD %ID_Path1%
IF EXIST REQUEST.ID$ DEL REQUEST.ID$
IF EXIST REQUEST.ID$ GOTO NoDelID$
IF EXIST REQUEST.ID_ DEL REQUEST.ID_
IF EXIST REQUEST.ID_ GOTO NoDelID_

:Skip
CD %PPP%
:: Definition der Hilfsvariablen wieder aufheben
FOR %%S IN (NewSize CopySize Once) DO SET %%S=
GOTO Ende
-= E N D - S U B =- -------------------------

:WDial_0 ---------- Unterprogramm "WDial_0"
:: existieren noch "auer Sichtweite gebrachte"
:: Brettlisten (*.RC$) oder REQUEST.ID$?
IF EXIST %RC_Path%\*.RC$ GOTO isRC$
IF EXIST %ID_Path%\REQUEST.ID$ GOTO isID$
IF EXIST %ID_Path%\REQUEST.ID_ GOTO isID_
GOTO Ende
-= E N D - S U B =- -------------------------

:SndNews ---------- Unterprogramm "SndNews"
:: aus der Request.id die News-Request-Datenstze entfernen und in 
:: Request.id$ sichern. Anschlieend den Erfolg dessen prfen.
CD %ID_Path1%
%PPP%\3Pa SplitReqID Request.id
:: innerhalb von 3Pa.exe Fehler aufgetreten
IF ERRORLEVEL==1 GOTO SplitErr
::
:MID_Req ---------- Unterprogramm "MID_Req"
:: Brettlisten "auer Sichtweite bringen" und den Erfolg dessen prfen
CD %RC_Path1%
IF EXIST *.RC REN *.RC *.RC$
IF EXIST *.RC GOTO NoRenRC
CD %PPP%
::
:: Dummy-Brettlisten erstellen
FOR %%F IN (%NewsName%) DO CALL 3P-News.bat NewsRC %%F
:: Semaphore setzen (beim Netcall "News nur senden")
3P QECHO "" > %RAM%\3P-News.tmp
GOTO Ende
-= E N D - S U B =- -------------------------

:NewsRC ---------- Unterprogramm "NewsRC"
:: leere RC-Files erstellen, sonst meldet UKAW den Fehler
:: "Error: Newsgroup File 'StarNews.RC' not found!"
:: (/nur/ wenn echte Liste der bestellten Newsgroups (jetzt *.RC$) existiert)
IF NOT EXIST %RC_Path%\%2.RC$ GOTO Ende
3P QEcho "" > %RC_Path%\%2.RC
GOTO Ende
-= E N D - S U B =- -------------------------

:: Unterprogramme mssen /immer/ hierher springen.
:Ende
:: Definition der Hilfsvariablen wieder aufheben
FOR %%S IN (RC_Path ID_Path RC_Path1 ID_Path1) DO SET %%S=
