@ECHO OFF
:: ===================================================
:: - Batch-Name: 3P-Sub.BAT                          -
:: ===================================================
:: -         Batch by Uwe Morgener - 05.2003         -
:: -      fuer Crosspoint (XP2/OpenXP) und UKAW      -
:: ---------------------------------------------------
:: - Zweck: enthlt einige Unterprogramme, die u.a.  -
:: - ====== wegen einiger "FOR IN DO"-Schleifen not- -
:: -        wendig sind.                             -
:: ---------------------------------------------------
:: -       (gehrt zum Paket: 3P-Batch v1.20)        -
:: ---------------------------------------------------

:: %2 enthlt die Sprungmarke (entspricht den Namen des "Unterprogramms")
:: kein Unterprogramm gewhlt? (Achtung: /Rekursiver Aufruf/)
IF %2'==' CALL 3P-Sub.bat NoSubDef ErrShow
IF %2'==' GOTO Ende
:: Unterprogramm "anspringen"
GOTO %2

:SetUUZ ---------- Unterprogramm "SetUUZ"
:: Hilfsroutine, um im UUZ-Aufruf die XP-Macros $PUFFER und $SPOOL
:: durch die Umgebungsvariablen %Puffer% %Spool% zu ersetzen
:: (nicht ganz simpel, beachtet aber die Gro-/KeinSchreibung der Parameter)
SET _Add=
ECHO %1|3P LMOD /B: SET _UUZaU=[$1U][+]SET _UUZa=[$1][+]SET _UUZbU=[$2U][+]SET _UUZb=[$2] > %RAM%\temp.bat
CALL %RAM%\temp.bat
IF %_UUZbU%'==' SET upper=%_UUZaU%
IF NOT %_UUZbU%'==' SET upper=%_UUZbU%
::
IF %upper%'==$PUFFER' SET _Add=%Puffer%
IF %upper%'==$SPOOL' SET _Add=%Spool%
:: neues XP-Macro (ab XP2v3.30.Pre2)
IF %upper%'==$BOX' SET _Add=-b%Boxname%
:: bersetzung fr XP2 v3.30.20b
IF %upper%'==$SCREENLINES' IF NOT %_UUZb%'==' SET _Add=%_UUZa%:%ScreenLines%
:: bersetzung fr XP2 v.3.30.Pre2
IF %upper%'==$SCREENLINES' IF %_UUZb%'==' SET _Add=-w:%ScreenLines%
::
:: kein 2teiliger Parameter
IF %_UUZb%%_Add%'==' SET _Add=%_UUZa%
:: -w:$XP-MACRO (2teiliger Parameter /mit/ XP-Macro)
IF NOT %_UUZb%'==' IF NOT %_Add%'==' SET _Add=%_UUZa%:%_Add%
:: -w:33 (2teiliger Parameter /ohne/ XP-Macro)
IF NOT %_UUZb%'==' IF %_Add%'==' SET _Add=%_UUZa%:%_UUZb%
::
:: Grund fr das "gehopse": W2k verarbeitet die Befehlszeile
:: "IF NOT %_UUZ%'==' SET _UUZ=%_UUZ% %_Add%" /nicht/ bis zur erforderlichen
:: Lnge korrekt!
IF NOT %_UUZ%'==' GOTO noEmpty
:: nachfolgendes wird /nur/ abgearbeitet, wenn %_UUZ% leer ist
SET _UUZ=%_Add%
GOTO Ende
::
:noEmpty
SET _UUZ=%_UUZ% %_Add%
GOTO Ende
-= E N D - S U B =- -------------------------

:AddLog ---------- Unterprogramm "AddLog"
:: Die einzelnen Log-Dateien der Fehlerklassen zu einer LOG-Datei zusammenfhren
::
:: nichts anzufgen, daher nur beenden
IF NOT EXIST %RAM%\3P-Mail$.%1 GOTO Ende
::
:: Fehlerklasse in Mail einfgen
ECHO. >>%RAM%\3P-Mail$.LOG
ECHO [ %1 ] >>%RAM%\3P-Mail$.LOG
:: %RAM%\3P-Mail$.%1 an 3P-Mail$.LOG anhngen
TYPE %RAM%\3P-Mail$.%1 >>%RAM%\3P-Mail$.LOG
:: %RAM%\3P-Mail$.%1 lschen
DEL %RAM%\3P-Mail$.%1
GOTO Ende
-= E N D - S U B =- -------------------------

:3PClear ---------- Unterprogramm "3PClear"
:: %1 = Anzahl der zu lschenden Zeilen
:: %3: 1 = ANSI-Farben setzen
::     0 = keine ANSI-Farben setzen
:: Fenster lschen (ab Zeile 4, %S_Row% Zeilen lschen) und Cursor neu setzen
3P WBAT FILL 4,1 (%1) " " ! CURSOR 5
:: ANSI-Treiber geladen, dann ANSI-Farben setzen (durch Bildschim-Ausschitt lschen)
IF %3'==1' GOTO SAnsiCol
GOTO Ende
-= E N D - S U B =- -------------------------

:SAnsiCol ---------- Unterprogramm "SetAnsiCol"
:: Farben setzen, wenn ein ANSI-Treiber geladen ist
:: (XP-Bildschirm, bis auf die Statuszeilen, komplett lschen)

:: ANSI-Treiber geladen, daher dies merken (Flag setzen)
SET Ansi=1

:: Cursorposition setzen (/auf/ die letzte der oberen XP-Statuszeilen)
ECHO [2;0H

:: ANSI-Farben zurcksetzen und die neuen holen
ECHO [0m
CALL VAR GET AnsiScreen FROM WBat.ini
:: wenn keine Farbe angegeben, dann ANSI-Farbe nur zurcksetzen
:: (entspricht white on black)
IF %AnsiScreen%'==' SET AnsiScreen=0m
SET ClearRow=[%AnsiScreen%[K
SET AnsiScreen=

:: Variablen initialisieren
:: Zhler auf "Null" setzen
SET count=
:: max. 50 Bildschirmzeilen mglich
SET target=**************************************************
:: Variable "target" auf die Anzahl der zu lschenden Zeilen krzen
CALL VAR SET target=STRING(1, %S_Row%) OF %target%

:: Bildschirm-Ausschnitt lschen (setzen der ANSI-Hintergrund-Farbe)
:AnsiLoop
:: eine Bildschirm-Zeile lschen
ECHO %ClearRow%
SET count=%count%*
:: noch nicht alle Zeilen des Bildschirm-Ausschnitts gelscht?
IF NOT %target%'==%count%' GOTO AnsiLoop

:: Cursorposition setzen
ECHO [4;0H

:: Hilfsvariablen lschen
FOR %%S IN (ClearRow count target) DO SET %%S=
GOTO Ende
-= E N D - S U B =- -------------------------

:CheckXP ---------- Unterprogramm "CheckXP"
:: XP-Varianten-Erkennung (%XPv% = 0 = XP2; %XPv% = 1 = OpenXP)
:: Hilfsvariablen initialiseren
FOR %%S IN (PPP_UUZ_Spool, Client-Spool) DO SET %%S=
:: mgliche Schlsselworte fr die Spoolverzeichnisse einlesen
IF EXIST %XP%\%1 CALL VAR GET PPP_UUZ_Spool, Client-Spool FROM %XP%\%1
:: beide Variablen leer, dann unbekannte XP-Varinate
IF %Client-Spool%%PPP_UUZ_Spool%'==' SET XPv=-1
:: es ist XP2 (RFC/PPP-Box)
IF NOT %PPP_UUZ_Spool%'==' SET XPv=0
:: es ist OpenXP (RFC/Client-Box)
IF NOT %Client-Spool%'==' SET XPv=1
:: Hilfsvariablen wieder lschen
FOR %%S IN (PPP_UUZ_Spool, Client-Spool) DO SET %%S=
GOTO Ende
-= E N D - S U B =- -------------------------

:WrCallBat ---------- Unterprogramm "WrCallbat"
:: Client-Eintrge aus der <Pollbox>.BFE holen, aufbereiten und
:: daraus fr OpenXP die CallTemp.bat generieren
3Pa ClientGet %1
IF ERRORLEVEL==1 SET Err=1
IF %Err%'==' CALL %RAM%\CallTemp.bat Dialer
GOTO Ende
-= E N D - S U B =- -------------------------

:SndShow ---------- Unterprogramm "SndShow"
:: Syntax: CALL 3P-Sub.bat 1 SndShow 0 News Mails
:: 1 .....= Nummer der Fehlermeldung
:: SndShow= Modulname (Name des Unterprogramms)
:: 0 .....= 0= Anzeige als Hinweis, 1= Anzeige als Fehlermeldung
:: News ..= Parameter 1 zur Ersetzung im Text der Hinweis-/Fehlermeldung
:: Mails..= Parameter 2 zur Ersetzung im Text der Hinweis-/Fehlermeldung

:: Hilfsvariablen initialisieren
FOR %%S IN (Label LogLabel) DO SET %%S=
FOR %%S IN (Err SndLoop) DO SET %%S=0

:: bergabeparameter fr die Nutzung im Text der Hinweis-/Fehlermeldung vorbereiten
SET P1=%4
SET P2=%5

:: LogFile-Verzeichnis und ...
:: (Config/Pfade/Logfile-Verzeichnis)
:: ... Einstellung, ob Tonsignal ausgeben werden soll
:: (Config/Anzeige../Hilfen/zustzliches Tonsignal)
SET LogDir=
IF EXIST %XP%\XPoint.cfg CALL VAR GET LogDir Tonsignal FROM %XP%\XPoint.cfg
IF %LogDir%'==' SET LogDir=%PPP%\
IF %Tonsignal%'==J' SET Beep=J
IF NOT %Tonsignal%'==J' SET Beep=N
SET Tonsignal=

:: Farben und Ton fr "Fehler-/Hinweismeldung nach dem Netcall" holen
IF %3'==0' CALL VAR GET [hcolor]WBoxTitle [hcolor]WBar [hcolor]WBox [hcolor]WBoxHi [hcolor]WDivider [hcolor]WShadow FROM WBat.ini
IF %3'==1' CALL VAR GET [mcolor]WBoxTitle [mcolor]WBar [mcolor]WBox [mcolor]WBoxHi [mcolor]WDivider [mcolor]WShadow FROM WBat.ini
CALL VAR GET SndBeep FROM WBat.ini
:: (%Beep% wird in WDial.bat bzw. UKAwPara.bat definiert)
IF %Beep%'==J' IF %XPAuto%'==Manu' 3P CSound %SndBeep%

:: Hinweis-/Fehlermeldung anzeigen und auf Besttigung warten (mit TimeOut)
:: (Eine Timeout-Zeit ist hier wichtig, damit auch automatische Netcall funktionieren)
3P WBAT MENU @:SndHint%SndRvdEr%%1 #1,30
:: existierte das Label "@:..." nicht (WBat-Meldung: "Label not found"),
:: dann Fehlermeldung ausgeben und in 3P-Batch.log schreiben.
IF ERRORLEVEL==255 SET Err=1
IF %Err%'==1' SET Label=@:SndHint%SndRvdEr%%1
IF %Err%'==1' 3P WBAT MENU @:NoLabel #1,30
IF %Err%'==1' CALL 3P-Sub.bat NoLabel ErrorMSG
::
:: aktuelles Label, fr Schreiben der Meldung in Log/Mail, merken
:: (notwendig, wegen mglichem Schleifendurchlauf)
SET LogLabel=%1
:SndLoop
:: Schleife max. 1* durchlaufen
IF %SndLoop%'==1' SET SndLoop=2
::
:: Meldung fr den Eintrag ins LogFile vorbereiten
IF %Err%'==0' CALL 3P-Sub.bat SndHint%LogLabel% ErrorMSG

:: Fehler in Log-Datei schreiben
3P LOGECHO $D.$M.$Y $h:$m %HLF%>>%LogDir%3P-Batch.LOG
:: Fehler fr Mail merken
3P LOGECHO   $h:$m:$s    %HLF%>>%RAM%\3P-Mail$.%ErrClass%

:: ggf. zustzlich "Client meldetete Fehler" an Log/Mail anfgen
IF NOT %1'==7' IF %SndLoop%%SndRvdEr%'==01' SET SndLoop=1
IF %SndLoop%'==1' SET LogLabel=7
IF %SndLoop%'==1' GOTO SndLoop

:: Definition der Hilfsvariablen (und Farben) wieder aufheben
FOR %%S IN (Err SndLoop Label LogLabel Beep) DO SET %%S=
FOR %%a IN (P1 P2 HLF ErrClass LogDir SndBeep) DO SET %%a=
FOR %%a IN (WBoxTitle WBar WBox WDivider WBoxHi WShadow) DO SET %%a=
GOTO Ende
-= E N D - S U B =- -------------------------

:_WriteBat ---------- Unterprogramm "WriteBat"
:: ====> derzeit nicht genutzt
:: Hilfsdateien VAR.BAT und W.BAT schreiben
SET x=32 37 5
3P QECHO "3P " 37 48 37 49 32 179 "VAR">VAR.BAT
3P QECHO %x%0 %x%1 %x%2 %x%3 %x%4 %x%5 %x%6 %x%7 CR LF>>VAR.BAT
3P QECHO "3P WBAT $W " 37 49 %x%0 %x%1 %x%2 %x%3 %x%4 %x%5 %x%6 %x%7 CR LF>W.BAT
:: Hilfsvariable lschen
SET x=
GOTO Ende
-= E N D - S U B =- -------------------------

:DirExist ---------- Unterprogramm "DirExist"
:: Versuchen, eine Datei (Semaphor) anzulegen
%PPP%\3P QEcho "" >%3\DirExist.tmp
:: nicht gelungen, d.h. das Verzeichnis existiert nicht, "Sprungmarke" setzen
IF NOT EXIST %3\DirExist.tmp SET Err=No%1
:: ist Verzeichnis /ohne/ abschlieenden Backslash angegeben?
IF EXIST %3\DirExist.tmp DEL %3\DirExist.tmp
:: wenn nicht gelscht, dann ist abschlieender Backslash vorhanden 
IF EXIST %3\DirExist.tmp SET Err=isSlash
IF %Err%'==' GOTO Ende

:: wenn Fehler aufgetreten, dann Meldung(en) von DOS lschen und Cursor neu setzen
%PPP%\3P WBat FILL 4 " " ! CURSOR 5
SET Slash_1=%1
SET Slash_2=%3
GOTO Ende
-= E N D - S U B =- -------------------------

:NewsSearch ---------- Unterprogramm "NewsSearch"
::
:: Prfung nicht Durchlaufen, wenn schon erkannt wurde, da die 1. an-
:: gegebene Box /nicht/ die Pollbox ist (da unerlaubte Einstellung)
IF %noFirst%'==1' GOTO Ende
:: 1. angegebene Box ist die Pollbox (Flag auf 2 setzen)
IF %1'==%BFG_NAME%' SET noFirst=2
:: 1. angegebene Box nicht die Pollbox (Flag auf 1 setzen)
IF %noFirst%'==0' SET noFirst=1
::
:: Postings von XP/UUZ ins Spoolverzeichnis gelegt? (0 = Ja)
IF %NewsSnd%'==0' GOTO NNTP
IF NOT EXIST %XP%\%1.pp GOTO NNTP
:: UUZ-Spoolverzeichnis von XP2 holen
IF %XPv%'==0' CALL VAR GET PPP_UUZ_Spool FROM %XP%\%1.BFG
:: UUZ-Spoolverzeichnis von OpenXP holen
IF %XPv%'==1' CALL VAR GET Client-Spool FROM %XP%\%1.BFG
IF EXIST %PPP_UUZ_Spool%%Client-Spool%N*.OUT SET NewsSnd=0
:NNTP
:: NewsServer in %1(.BFG) eingetragen? (0 = Ja)
IF %NNTP%'==0' GOTO Ende
:: XP2
IF %XPv%'==0' 3P XGREP -y "^NntpServer=.+" %XP%\%1.BFG >NUL
:: OpenXP
IF %XPv%'==1' 3P XGREP -y "^Client-NewsServer=.+" %XP%\%1.BFG >NUL
IF NOT ERRORLEVEL==1 SET NNTP=0
::
:: fr diese Box Postings vorhanden aber kein News-Server eingetragen,
:: dann NewsSnd wieder auf "keine News zum Versand" setzen
:: (News knnen nur versandt werden, wenn der NNTP-Server eingetragen ist)
IF %NewsSnd%%NNTP%'==01' SET NewsSnd=1
::
::Unterprogramm beenden => Rcksprung zum aufrufenden Modul
GOTO Ende
-= E N D - S U B =- -------------------------

:_MailSearch ---------- Unterprogramm "MailSearch"
:: ====> derzeit nicht genutzt
:: ACHTUNG: in %1 mu der BFG-Name und /nicht/ der Name der Box stehen
:: Mails von XP/UUZ ins Spoolverzeichnis gelegt? (0 = Ja)
IF %MailSnd%'==0' GOTO POP3
IF NOT EXIST %XP%\%1.pp GOTO POP3
CALL VAR GET PPP_UUZ_Spool FROM %XP%\%1.BFG
IF EXIST %PPP_UUZ_Spool%M*.OUT SET MailSnd=0
:POP3
:: MailInServer in %1.BFG eingetragen? (0 = Ja)
IF %POP3%'==0' GOTO SMTP
3P XGREP -y "^Pop3Server=.+" %XP%\%1.BFG >NUL
IF NOT ERRORLEVEL==1 SET POP3=0
:SMTP
:: MailOutServer in %1.BFG eingetragen? (0 = Ja)
IF %SMTP%'==0' GOTO Ende
3P XGREP -y "^SmtpServer=.+" %XP%\%1.BFG >NUL
IF NOT ERRORLEVEL==1 SET SMTP=0
::
:: fr diese Box Mails vorhanden aber kein SMTP-Server eingetragen,
:: dann MailSnd wieder auf "keine Mail zum Versand" setzen
:: (Mails knnen nur versandt werden, wenn der SMTP-Server eingetragen ist)
IF %MailSnd%%SMTP%'==01' SET MailSnd=1
::
::Unterprogramm beenden => Rcksprung zum aufrufenden Modul
GOTO Ende
-= E N D - S U B =- -------------------------

:WrBoxCFG ---------- Unterprogramm "WrBoxCFG"
CALL VAR GET BoxName FROM %1
CALL VAR SET BfgName NAME OF %1
CALL VAR SET BfgName=STRING(1,8) "%BfgName%%_Trenn%"
ECHO %BfgName%: %Boxname%>>3P-Boxen.Lst
SET _BoxName=%_BoxName% %BoxName%
:: Hilfsvariablen lschen
FOR %%a IN (BoxName BfgName) DO SET %%a=
GOTO Ende
-= E N D - S U B =- -------------------------

:_BFGinVAR ---------- Unterprogramm "BFGinVAR"
:: ====> derzeit nicht genutzt
:: Erweiterung (*.BFG) in Umgebungsvariable
CALL VAR SET Ext=EXT OF %1 /U
:: Name der *.BFG (ohne Erweiterung) in Umgebungsvariable
CALL VAR SET FileName=NAME OF %1 /U
:: wenn XP-Macro, dann durch den zugehrenden BFG-Namen ersetzen
IF %FileName%'==$CONFIG' SET _BFGName=%_BFGName% %BFG_Name%
:: wenn Erweiterung=BFG, dann BFG-Namen an Liste anzufgen
IF %Ext%'==BFG' SET _BFGName=%_BFGName% %FileName%
GOTO Ende
-= E N D - S U B =- -------------------------

:_isMail ---------- Unterprogramm "isMail"
:: ====> derzeit nicht genutzt
:: prfen, ob noch Mails zum Versand anstehen
IF %MSndErr%'==1' GOTO Ende
IF NOT EXIST %XP%\%1.BFG GOTO Ende
CALL VAR GET PPP_UUZ_Spool FROM %XP%\%1.BFG
IF EXIST %PPP_UUZ_Spool%M*.OUT SET MSndErr=1
GOTO Ende
-= E N D - S U B =- -------------------------

:isNews ---------- Unterprogramm "isNews"
:: prfen, ob noch News zum Versand anstehen
IF %NSndErr%'==1' GOTO Ende
IF NOT EXIST %XP%\%1.BFG GOTO Ende
:: UUZ-Spoolverzeichnis von XP2 holen
IF %XPv%'==0' CALL VAR GET PPP_UUZ_Spool FROM %XP%\%1.BFG
:: UUZ-Spoolverzeichnis von OpenXP holen
IF %XPv%'==1' CALL VAR GET Client-Spool FROM %XP%\%1.BFG
IF EXIST %PPP_UUZ_Spool%%Client-Spool%N*.OUT SET NSndErr=1
GOTO Ende
-= E N D - S U B =- -------------------------

:ErrShow ---------- Unterprogramm "ErrShow"
::
:: "HighLevel-Fehlertexte" --------------------------------------------
::
:: Wichtig: das aktuelle Verzeichnis mu %PPP% sein.
::
:: Aufruf: CALL 3P-Sub.bat {Fehlertext auswhlen} ErrShow [/No]
::         /No: "/NoCall" /nicht/ in die UKAwPara.bat schreiben
::
:: LogFile-Verzeichnis und ...
:: (Config/Pfade/Logfile-Verzeichnis)
:: ... Einstellung, ob Tonsignal ausgeben werden soll
:: (Config/Anzeige../Hilfen/zustzliches Tonsignal)
SET LogDir=
IF EXIST %XP%\XPoint.cfg CALL VAR GET LogDir Tonsignal FROM %XP%\XPoint.cfg
IF %LogDir%'==' SET LogDir=%PPP%\
IF %Tonsignal%'==J' SET Beep=J
IF NOT %Tonsignal%'==J' SET Beep=N
SET Tonsignal=

:: Farben und Ton fr die Fehlermeldung holen
CALL VAR GET [mcolor]WBoxTitle [mcolor]WBar [mcolor]WBox [mcolor]WBoxHi [mcolor]WDivider [mcolor]WShadow FROM WBat.ini
CALL VAR GET ErrBeep FROM WBat.ini
:: (%Beep% wird in WDial.bat bzw. UKAwPara.bat definiert)
IF %Beep%'==J' IF %XPAuto%'==Manu' 3P CSound %ErrBeep%

:: die Fllzeichen von %$Mod$% entfernen und als %_Mod$% merken
:: _Mod$: Verwendung in 3P-A_Lay.out
:: $Mod$: Verwendung in 3P-B_Lay.out
IF %$Mod$%'==' SET $Mod$=???????
ECHO %$Mod$% | 3P LMOD /S. SET _Mod$=[$1] > %RAM%\temp.bat
CALL %RAM%\temp.bat
DEL %RAM%\temp.bat

:: fr 3P-Men eine andere Abschlumeldung definieren
IF %$Mod$%'==3P-Men' SET _Meldung=Es wurde keine Konfigurationsdatei erstellt.
IF %_Meldung%'==' SET _Meldung=Der NetCall wird daher nicht durchgefhrt...

:: Fehlermeldung anzeigen und auf Besttigung warten (mit TimeOut)
:: (Eine Timeout-Zeit ist hier wichtig, damit auch automatische Netcall funktionieren)
:: Label setzen (wird ggf. fr die Fehlerbehandlung bentigt)
SET Err=0
3P WBAT MENU @:%1 #1,30
:: existierte das Label "@:%1" nicht (WBat-Meldung: "Label not found"),
:: dann Fehlermeldung ausgeben und in 3P-Batch.log schreiben.
IF ERRORLEVEL==255 SET Err=1
IF %Err%'==1' SET Label=%1
IF %Err%'==1' 3P WBAT MENU @:NoLabel #1,30
IF %Err%'==1' CALL 3P-Sub.bat NoLabel ErrorMSG
::
:: Fehler-Meldung fr den Eintrag ins LogFile vorbereiten
IF %Err%'==0' CALL 3P-Sub.bat %1 ErrorMSG
FOR %%S IN (Label Err) DO SET %%S=

:: Fehler in Log-Datei schreiben
3P LOGECHO $D.$M.$Y $h:$m | 3P LMOD /B [] %HLF%>>%LogDir%3P-Batch.LOG
:: Fehler fr Mail merken
3P LOGECHO   $h:$m:$s | 3P LMOD /B []    %HLF%>>%RAM%\3P-Mail$.%ErrClass%

:: Definition der Hilfsvariablen (und Farben) wieder aufheben
FOR %%a IN (Datei Mail News WBat HLF ErrClass LogDir ErrBeep) DO SET %%a=
FOR %%a IN (WBoxTitle WBar WBox WDivider WBoxHi WShadow Beep) DO SET %%a=
FOR %%a IN (_Mod$ _Meldung) DO SET %%a=
:: kein Netcall durchgefhrt - kann genutzt werden, um in einem solchem
:: Fall den Eingangsfilter nicht abzuarbeiten (per zustzlicher Batch)
IF %3'==/No' GOTO Ende
ECHO SET UKAwPara=/NoCall> %RAM%\UKAwPara.bat
GOTO Ende
-= E N D - S U B =- -------------------------

:ErrorMSG ---------- Unterprogramm "ErrorMSG"
:: Hilfsvariablen "initialisieren"
FOR %%S IN (ErrClass HLF) DO SET %%S=
::
:: High-Level-Fehlermeldung (HLF) und Fehler-Klasse (ErrClass)
:: einlesen und zerlegen (in ErrClass & HLF)
3P WBAT STDOUT @3P-B_Lay.out:%1 | 3P LMod /B# SET ErrClass=[$1][+]SET HLF=[$2] > %RAM%\temp.bat
CALL %RAM%\temp.bat
DEL %RAM%\temp.bat
:: existierte das Label "@3P-B_Lay.out:%1" nicht (WBat-Meldung: "Label not found"),
:: dann Fehlermeldung ausgeben und in 3P-Batch.log schreiben.
IF %ErrClass%'==' SET Label=@3P-B_Lay.out:%1
IF %ErrClass%'==' 3P WBAT MENU @:NoLabel #1,30
IF %ErrClass%'==' CALL 3P-Sub.bat NoLabel ErrorMSG
:: Hilfsvariable wieder lschen
SET Label=
GOTO Ende
-= E N D - S U B =- -------------------------

:Mail ---------- Unterprogramm "Mail"
:: ---------------------------------------------------
:: - Zweck: Fehlermeldung als Mail ins interne Brett -
:: - ====== Meldungen legen. Die Mail wird aus den  -
:: - Dateien Betreff.tmp und Body.tmp und dem ber-  -
:: - gabeparameter (=Absenderadresse) generiert.     -
:: ---------------------------------------------------
:: ACHTUNG: Ob die Umgebungsvariable %XP% und/oder das
:: ======== XP-Autoexec-Verzeichnis existiert, wird
:: hier nicht berprft - erfolgte in WDial.bat
:: ---------------------------------------------------
:: Fehlt der bergabeparameter (Absender) oder die
:: Datei Betreff.tmp, dann wird keine Mail erstellt,
:: sondern nur eine Info ber den fehlerhaften Aufruf
:: ins Log-File "3P-Batch.log" geschrieben
:: ---------------------------------------------------
:: Beispiele fr den Aufruf:
:: -------------------------
:: WICHTIG: 3P-Sub.bat, 3P.com, Betreff.tmp und 
:: ======== Body.tmp mssen im gleichen Verzeichnis
:: liegen und aus diesem heraus aufgerufen werden
::
:: Erstelle Fehlermeldung /mit/ Body
::     Betreff definieren
::     ECHO Fehler: E-Agent nicht gefunden>Betreff.tmp
::     Body definieren
::     ECHO (Nachrichtentext)>Body.tmp
::     Modul "Mail" aufrufen (inkl. linken Teil des
::                            Absender festlegen)
::     CALL 3P-Sub.bat 3P-Konv Mail
::
:: Erstelle Fehlermeldung /ohne/ Body
::     ECHO Fehler: E-Agent nicht gefunden>Betreff.tmp
::     REM>Body.tmp
::     CALL 3P-Sub.bat 3P-Konv Mail
:: ---------------------------------------------------

:: prfen, ob (restliche) notwendige Umgebung vorhanden
IF %1'==' GOTO MError
IF NOT EXIST Betreff.tmp GOTO MError

:: Name (inkl. Pfad) der ErrorMSG-Datei festlegen
SET ErrorMSG=%XP%\AUTOEXEC\ErrorMSG.zer

:: Empfnger festlegen
IF %3'==' SET EMP=/Meldungen
IF NOT %3'==' SET EMP=%3

ECHO EMP: %EMP%>> %ErrorMSG%
ECHO ABS: %1@3P-Batch.local (%1)>> %ErrorMSG%
3P QECHO "BET: ">> %ErrorMSG%
TYPE Betreff.tmp>> %ErrorMSG%
ECHO ROT: localhost>> %ErrorMSG%
ECHO MAILER: 3P-Batch [localhost]>> %ErrorMSG%
3P LOGECHO EDA: $C$Y$M$D$h$m$sW+0>> %ErrorMSG%
3P LOGECHO MID: $C$Y$M$D$h$m$s@3P-Batch.local>> %ErrorMSG%

IF EXIST Body.tmp GOTO MBody
:MNoBody
ECHO LEN: 2>> %ErrorMSG%
ECHO.>> %ErrorMSG%
ECHO.>> %ErrorMSG%
GOTO MEnde

:MBody
CALL VAR SET C=SIZE OF Body.tmp
IF %C%'==0' GOTO MNoBody
ECHO LEN: %C%>> %ErrorMSG%
ECHO.>> %ErrorMSG%
TYPE Body.tmp>> %ErrorMSG%
GOTO MEnde

:MError
:: LogFile-Verzeichnis einlesen und prfen, ob es auch existiert
CALL VAR GET LogDir FROM %XP%\XPoint.cfg
IF NOT EXIST %LogDir%NUL SET LogDir=%PPP%\
3P LOGECHO $D.$M.$Y $h:$m Fehler: falsche Umgebung beim Aufruf von "%0">>%LogDir%3P-Batch.LOG
IF %1'==' 3P LOGECHO                        bergabeparameter fehlt>>%LogDir%3P-Batch.LOG
IF NOT EXIST Betreff.tmp 3P LOGECHO                        Betreff.tmp fehlt>>%LogDir%3P-Batch.LOG

:MEnde
:: temporre Dateien und Umgebungsvariablen wieder lschen
IF EXIST Betreff.tmp DEL Betreff.tmp
IF EXIST Body.tmp DEL Body.tmp
FOR %%S IN (EMP ErrorMSG C LogDir) DO SET %%S=
GOTO Ende
-= E N D - S U B =- -------------------------

:Menue_1 ---------- Unterprogramm "Menue_1"
:: liegen keine Mails und/oder News zum Versandt vor, dann nicht bentigte
:: Menpunkte "deaktivieren" (eines von 4 Men-Profilen (MailX/NewsX) auswhlen)
:: undokumentierte Menpunkte knnen SET Request=1 aktiviert werden
:: (eines der 4 Alternativ-Men-Profile (Mail1X/News1X) auswhlen

:: Mail-Men aufrufen ----------------------------
:: #1,%TimeOut% = bedeutet: nach Ablauf des TimeOut-Wertes (SET TimeOut=)
::                den 1. Menpunkt auswhlen
::                Default ist also Menpunkt "0. Mails empfangen/senden"

:: Men aufrufen
:: wenn weder Mail zum holen (kein Pop3Server eingetragen) noch zum Versenden
:: vorhanden, dann ...
:: ... Menpunkt "keine Mail-Bearbeitung" whlen
:: Vorsicht beim ndern der Mail-/News-Menreihenfolge (wegen SET MAIL=1)
IF %Pop3%%MSnd%'==11' SET Mail=1
:: ... kein Mailmen anzeigen
IF %Pop3%%MSnd%'==11' GOTO NewsSnd
::
:: Vorsicht beim ndern der Mail-/News-Menreihenfolge (wegen #1+%Pop3+%MSnd%)
CALL W.Bat BOX @:Mail%Pop3%%MSnd% #1+%Pop3%+%MSnd%,%TimeOut%
:: Errorlevel bzw. %?% 100 = Esc, Errorlevel 255 = Fehler)
IF Errorlevel==255 GOTO MWBatErr
IF %?%'==100' GOTO MAbbruch
:: Auswahl (Menposition) zuweisen
SET MAIL=%WBat%

:NewsSnd
:: News-Men aufrufen ----------------------------
:: Wenn kein NNTP-Server eingetragen, dann ...
:: ... Menpunkt "keine News-Bearbeitung" whlen
:: Vorsicht beim ndern der Mail-/News-Menreihenfolge (wegen SET NEWS=1)
IF %Nntp%'==1' SET News=1
:: ... kein Newsmen anzeigen
IF %Nntp%'==1' GOTO MAbbruch
::
CALL W.Bat BOX @:News%Request%%NewsSnd% #1+%NewsSnd%,%TimeOut%
IF Errorlevel==255 GOTO MWBatErr
IF %?%'==100' GOTO MAbbruch
SET NEWS=%WBat%

:MAbbruch
:MWBatErr
:: Definition der Hilfsvariable wieder aufheben
SET Time=
GOTO Ende
-= E N D - S U B =- -------------------------

:Menue_2 ---------- Unterprogramm "Menue_2"

:: prfen, ob Mails und/oder News zum Versandt vorliegen,
:: Pop3-, Smtp- und/oder Nntp-Server in Multi-Server-Box eingetragen 
:: und nicht bentigte Menpunkte "deaktivieren"
:: ===========================================================
:: Pop3...: POP3-Server eingetragen?
:: MSnd...: existieren Mails zum Versand?
:: Nntp...: NNTP-Server eingetragen?
:: NewsSnd: existieren News zum Versand?
:: xSnd...: existieren Mails und/oder News zum Versand?
:: 0 steht fr ja; 1 steht fr nein
::

:: temporres Men generieren
CALL VAR GET M2_Title M2_Line M2_Abbr FROM 3P-A_Lay.out
::
ECHO %M2_Title%>3P-Menu.tmp
ECHO.>>3P-Menu.tmp
::
IF %MSnd%'==0' SET xSnd=0
IF %NewsSnd%'==0' SET xSnd=0
IF %Pop3%%Nntp%%xSnd%'==000' CALL VAR GET M2_0_J FROM 3P-A_Lay.out
IF NOT %Pop3%%Nntp%%xSnd%'==000' CALL VAR GET M2_0_N FROM 3P-A_Lay.out
IF %M2_0_N%'==' ECHO %M2_0_J%>>3P-Menu.tmp
IF %M2_0_J%'==' ECHO %M2_0_N%>>3P-Menu.tmp
SET xSnd=
FOR %%S IN (J N) DO SET M2_0_%%S=
::
IF %Pop3%%Nntp%'==00' CALL VAR GET M2_1_J FROM 3P-A_Lay.out
IF NOT %Pop3%%Nntp%'==00' CALL VAR GET M2_1_N FROM 3P-A_Lay.out
IF %M2_1_N%'==' ECHO %M2_1_j%>>3P-Menu.tmp
IF %M2_1_J%'==' ECHO %M2_1_N%>>3P-Menu.tmp
FOR %%S IN (J N) DO SET M2_1_%%S=
::
ECHO %M2_Line%>>3P-Menu.tmp
IF %Pop3%%MSnd%'==00' CALL VAR GET M2_2_J FROM 3P-A_Lay.out
IF NOT %Pop3%%MSnd%'==00' CALL VAR GET M2_2_N FROM 3P-A_Lay.out
IF %M2_2_N%'==' ECHO %M2_2_j%>>3P-Menu.tmp
IF %M2_2_J%'==' ECHO %M2_2_N%>>3P-Menu.tmp
FOR %%S IN (J N) DO SET M2_2_%%S=
::
IF %Pop3%'==0' CALL VAR GET M2_3_J FROM 3P-A_Lay.out
IF NOT %Pop3%'==0' CALL VAR GET M2_3_N FROM 3P-A_Lay.out
IF %M2_3_N%'==' ECHO %M2_3_j%>>3P-Menu.tmp
IF %M2_3_J%'==' ECHO %M2_3_N%>>3P-Menu.tmp
FOR %%S IN (J N) DO SET M2_3_%%S=
::
IF %MSnd%'==0' CALL VAR GET M2_4_J FROM 3P-A_Lay.out
IF NOT %MSnd%'==0' CALL VAR GET M2_4_N FROM 3P-A_Lay.out
IF %M2_4_N%'==' ECHO %M2_4_j%>>3P-Menu.tmp
IF %M2_4_J%'==' ECHO %M2_4_N%>>3P-Menu.tmp
FOR %%S IN (J N) DO SET M2_4_%%S=
::
ECHO %M2_Line%>>3P-Menu.tmp
::
IF %Nntp%%NewsSnd%'==00' CALL VAR GET M2_5_J FROM 3P-A_Lay.out
IF NOT %Nntp%%NewsSnd%'==00' CALL VAR GET M2_5_N FROM 3P-A_Lay.out
IF %M2_5_N%'==' ECHO %M2_5_j%>>3P-Menu.tmp
IF %M2_5_J%'==' ECHO %M2_5_N%>>3P-Menu.tmp
FOR %%S IN (J N) DO SET M2_5_%%S=
::
IF %Nntp%'==0' CALL VAR GET M2_6_J FROM 3P-A_Lay.out
IF NOT %Nntp%'==0' CALL VAR GET M2_6_N FROM 3P-A_Lay.out
IF %M2_6_N%'==' ECHO %M2_6_j%>>3P-Menu.tmp
IF %M2_6_J%'==' ECHO %M2_6_N%>>3P-Menu.tmp
FOR %%S IN (J N) DO SET M2_6_%%S=
::
IF %Nntp%%NewsSnd%'==00' CALL VAR GET M2_7_J FROM 3P-A_Lay.out
IF NOT %Nntp%%NewsSnd%'==00' CALL VAR GET M2_7_N FROM 3P-A_Lay.out
IF %M2_7_N%'==' ECHO %M2_7_j%>>3P-Menu.tmp
IF %M2_7_J%'==' ECHO %M2_7_N%>>3P-Menu.tmp
FOR %%S IN (J N) DO SET M2_7_%%S=
::
ECHO %M2_Line%>>3P-Menu.tmp
::
ECHO %M2_Abbr%>>3P-Menu.tmp
FOR %%S IN (M2_Title M2_Line M2_Abbr) DO SET M2_0_%%S=

:: temporres Men aufrufen ----------------------------
:: #1,%TimeOut% = bedeutet: nach Ablauf des TimeOut-Wertes (SET TimeOut=)
::                den 1. Menpunkt auswhlen
::                Default ist also Menpunkt "0. Mails empfangen/senden"
CALL W.Bat BOX @3P-Menu.tmp:Menue2 #1,%TimeOut%
:: Errorlevel bzw. %?% 100 = Esc, Errorlevel 255 = Fehler)
IF Errorlevel==255 GOTO NWBatErr
IF %WBat%'==Abbruch' SET ?=100
IF %?%'==100' GOTO NAbbruch

:: Auswahl (Menposition) zuweisen
:: und bersetzen (trennen nach %MAIL% und %NEWS%)
:: Menpunkt 0 differenzierter betrachten:
::  - Mails und News senden und empfangen
IF %WBat%%MSnd%%NewsSnd%'==000' SET Wahl=00
::  - keine News zum Senden vorhanden, daher News nur empfangen
IF %WBat%%MSnd%%NewsSnd%'==001' SET Wahl=02
::  - keine Mails zum Senden vorhanden, daher Mails nur empfangen
IF %WBat%%MSnd%%NewsSnd%'==010' SET Wahl=20
::
IF %WBat%'==1' SET Wahl=22
IF %WBat%'==2' SET Wahl=01
IF %WBat%'==3' SET Wahl=21
IF %WBat%'==4' SET Wahl=31
IF %WBat%'==5' SET Wahl=10
IF %WBat%'==6' SET Wahl=12
IF %WBat%'==7' SET Wahl=13
CALL VAR SET Mail=STRING(1,1) %Wahl%
CALL VAR SET News=STRING(2,1) %Wahl%

:NAbbruch
:NWBatErr
:: temporre Men-Datei wieder lschen
IF EXIST 3P-Menu.tmp DEL 3P-Menu.tmp
:: Definition der Hilfsvariable wieder aufheben
FOR %%a IN (Wahl MailNews Time) DO SET %%a=
GOTO Ende
-= E N D - S U B =- -------------------------

:: Unterprogramme mssen /immer/ hierher springen.
:Ende
