@ECHO OFF
:: =====================================================
:: - Batch-Name: Install.BAT                           -
:: =====================================================
:: -          Batch by Uwe Morgener - 05.2003          -
:: -       fuer Crosspoint (XP2/OpenXP) und UKAW       -
:: -----------------------------------------------------
:: - Zweck: Start-Batch fr Crosspoint/3P-Batch        -
:: - ====== schreiben, welche alle notwendigen Umge-   -
:: - bungsvariablen setzt und anschlieend Crosspoint  -
:: - aufruft.                                          -
:: - Hinweis: Diese Batch mu im 3P-Batch-Verzeichnis  -
:: - -------- liegen und aus diesem heraus gestartet   -
:: - werden (Alternativ ber Windows: Start/Ausfhren).-
:: - 3P-Batch-Verzeichnis mu ein Unterverzeichnis vom -
:: - Crosspoint-Verzeichnis sein.                      -
:: - ------------------------------------------------- -
:: -        (gehrt zum Paket: 3P-Batch v1.20)         -
:: -----------------------------------------------------
GOTO Start

:noPPPDir
ECHO Fehler aufgetreten...
ECHO Start-Verzeichnis ist nicht das 3P-Batch-Verzeichnis.
ECHO.
PAUSE
GOTO Ende

:Start
:: Umgebungsvariable %windir% (kleingeschrieben) kann von 3Pa.exe nicht
:: gelesen werden, daher nach %WINDIR% (grogeschrieben) bringen
SET WINDIR=%windir%

:: prfen, ob das aktuelle Verzeichnis das 3P-Batch-Verzeichnis ist
::REM:: (sonst wird leere "XP-Start.bat" erzeugt)
IF NOT EXIST 3Pa.exe GOTO noPPPDir
IF NOT EXIST 3P.com GOTO noPPPDir
:: ggf. im 3P-Batch-Verzeichnis existierende XP-Start.bat lschen
IF EXIST XP-Start.bat DEL XP-Start.bat

:: Werte fr alle ntigen Umgebungsvariablen ermitteln
:: und daraus eine XP-Start.bat erstellen
3Pa.exe Install > XP-Start.bat

:Ende
